% histogram, cut by values in bins
% H(i) = #elements of A in [bins(i-1),bins(i))

% For bins, use linspace(LO,HI,N) or logspace(LO,HI,N).

function [H,vals,steps] = histo(A,bins)
   nbins = size(bins,2)
   H = zeros(1,nbins+1);
   for i = 1:nbins
      I = find(A>bins(i));
      H(i) = size(A,2) - size(I,2);
      if size(I,2) == 0
	 A = [];
	 break;
      end
      A = A(I);
   end
   H(nbins+1) = size(A,2);
   vals = ([bins(1),bins]+[bins,bins(nbins)])/2;
   steps = bins(2:nbins)-bins(1:nbins-1);
   steps = [steps(1),steps,steps(nbins-1)];
end;