% readpgm --  reads a grayscale image file in PGM RAW format.

function image = readpgm(filename)

   if (nargin < 1) 
      error('Too few input arguments.');
   elseif (isstr(filename)) 
      fid = fopen(filename,'r');
      if (fid < 0) error(['Can not open file: ',filename]); end
   elseif (filename>=0 & filename<256)
      fid = floor(filename);
   else
      error('Argument must be a string.'); 
   end;

   idline = fgetl(fid) ;
   if (~isstr(idline)) 
      error(['File is empty: ',filename]); 
   elseif (idline(1) ~= 'P') 
      error(['Not a PNM file: ',filename]); 
   elseif (idline(2) ~= '5' & idline(2) ~= '2')
      error(['PNM but not PGM file: ',filename]); 
   end

   whline = fgetl(fid);
   if length(whline) == 0, whline(1) = '#'; end
   while whline(1) == '#', 
      whline = fgetl(fid);
      if length(whline) == 0, whline(1) = '#'; end
   end
   [vek, count] = sscanf(whline,' %d',2);
   width = vek(1);
   height = vek(2);

   whline = fgetl(fid);
   if length(whline) == 0, whline(1) = '#'; end
   while whline(1) == '#', 
      whline = fgetl(fid);
      if length(whline) == 0, whline(1) = '#'; end
   end
   [range, count] = sscanf(whline,' %d',1);
   
   if (idline(2) == '5')
      [image,count] = fread(fid,[width height],'uchar') ;
   elseif (idline(2) == '2')
      [image,count] = fscanf(fid,' %d ',[width height]);
   end
   if (isstr(filename)) fclose(fid); end;
%end;
