% writemat1 -- writes a (list of) matrix(ces) in simple format 
%   mrows ncols
%   A11 A12 ... A1n
%   ...
%   Am1 Am2 ... Amn

function ok = writemat1(file,A,mode)
   opened = 0;
   if nargin<3, mode = 'w'; end
   if (nargin < 1) 
      error('Filename argument missing.');
   elseif (isstr(file)) 
      fid = fopen(file,mode);
      if (fid < 0) error(['Can not open file: ',file]); end
      opened = 1;
   elseif (file>=0 & file<256)
      fid = floor(file);
   else
      error('Argument must be a string or file ID.'); 
   end
   [m,n] = size(A);
   fprintf(fid,'%d %d\n',m,n);
   for i=1:m
      fprintf(fid,'%g ',A(i,:));
      fprintf(fid,'\n');
   end
   if opened, fclose(fid); end
end
